      LOGICAL FUNCTION  DCODE (S,F,L,V)
C     (Decode)
C     Decodes string of decimal digits.  DCODE=.FALSE. on  return
C     if any errors are encountered.
C
C     Arguments:
C     S = string containing decimal digits,
C     F = index of first byte of field in S,
C     L = index of last byte of field in S,
C     V = value to be decoded.
C     (23-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      INTEGER             DECVAL
      LOGICAL             DECDIG
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                ACHAR,       DONE,        ERROR,       N
C     SETS                NUMBER,      SIGN,        V
C
      INTEGER             ACHAR,       F,           IARG,        L
      INTEGER             N,           S(1),        SIGN,        V
      LOGICAL             DONE,        ERROR,       NUMBER
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM04  /
C
      INTEGER             ARZ,         BLNKRZ,      COLNRZ,      CRZ
      INTEGER             DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      INTEGER             PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      INTEGER             STARRZ,      ZERORZ,      ZRZ
C
      COMMON / COM04  /   ARZ,         BLNKRZ,      COLNRZ,      CRZ
      COMMON / COM04  /   DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      COMMON / COM04  /   PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      COMMON / COM04  /   STARRZ,      ZERORZ,      ZRZ
C
C
C
C     LOGICAL statement function returning .TRUE. if right-zero
C     character argument is a decimal digit.
C
      DECDIG(IARG) = (ZERORZ .LE. IARG) .AND. (IARG .LE. NINERZ)
C
C     INTEGER statement function returning integer value of a
C     character which is known to represent a digit.
C
      DECVAL(IARG) = IARG - ZERORZ
C
      V=0
      N=F
      SIGN=0
      ERROR=.FALSE.
      NUMBER=.FALSE.
      DONE=.FALSE.
20001 IF (.NOT.(N.LE.L .AND. .NOT.ERROR)) GO TO 20002
      ACHAR = CHGET3 (S,N)
      IF (.NOT.(ACHAR.EQ.BLNKRZ)) GO TO 20003
      DONE=NUMBER
      GO TO 20004
20003 IF (.NOT.(ACHAR.EQ.PLUSRZ.OR.ACHAR.EQ.DASHRZ)) GO TO 20006
      ERROR=NUMBER .OR. SIGN.NE.0
      SIGN=ACHAR
      GO TO 20007
20006 NUMBER=.TRUE.
      ERROR = DONE .OR. .NOT.DECDIG(ACHAR)
      IF (.NOT.ERROR) V = 10*V + DECVAL(ACHAR)
20007 CONTINUE
20008 CONTINUE
20004 CONTINUE
20005 N=N+1
      GO TO 20001
20002 IF (SIGN.EQ.DASHRZ)  V=-V
      DCODE = NUMBER .AND. .NOT.ERROR
C
      RETURN
      END
